pipeline {
     agent {
        ecs {
            inheritFrom 'build-example'
        }
     }

    environment {
        AWS_ACCOUNT_ID="434401341886"
        AWS_DEFAULT_REGION="ap-south-1" 
        IMAGE_REPO_NAME="mera1k-staging"
        IMAGE_TAG="mera1klatest"
        REPOSITORY_URI = "${AWS_ACCOUNT_ID}.dkr.ecr.${AWS_DEFAULT_REGION}.amazonaws.com/${IMAGE_REPO_NAME}"
        registryCredential = '1k-staging-credentials'
    }
   
    stages {
         
         stage('Logging into AWS ECR') {
            steps {
                withAWS(credentials: '1k-staging-credentials', region: 'ap-south-1'){
                 script {
                sh "aws --version"   
                sh "aws ecr get-login-password --region ${AWS_DEFAULT_REGION} | docker login --username AWS --password-stdin ${AWS_ACCOUNT_ID}.dkr.ecr.${AWS_DEFAULT_REGION}.amazonaws.com"
                }
                }
                
                 
            }
        }
        
        stage('Cloning Git') {
            steps {
                checkout([$class: 'GitSCM', branches: [[name: '*/mera1kdocker']], doGenerateSubmoduleConfigurations: false, extensions: [], submoduleCfg: [], userRemoteConfigs: [[credentialsId: '', url: 'https://gitlab.com/niyotail/mera1k.git']]])     
            }
        }
  
    // Building Docker imagess
    stage('Building image') {
      steps{
        script {
          dockerImage = docker.build "${IMAGE_REPO_NAME}:${IMAGE_TAG}"
        }
      }
    }
   
    // Uploading Docker images into AWS ECR
    stage('Pushing to ECR') {
     steps{  
         withAWS(credentials: '1k-staging-credentials', region: 'ap-south-1')
         script {
                sh "docker tag ${IMAGE_REPO_NAME}:${IMAGE_TAG} ${REPOSITORY_URI}:$IMAGE_TAG"
                sh "docker push ${AWS_ACCOUNT_ID}.dkr.ecr.${AWS_DEFAULT_REGION}.amazonaws.com/${IMAGE_REPO_NAME}:${IMAGE_TAG}"
         }
        }
      }
    }
}
